                     /*ͻ
                      C Easy samplef.c: Music, sort of 
                     */

#include "\ceasy\ceasy1.h"
#include "\ceasy\ceasy2.h"

#define C 262
#define D 294
#define E 330
#define F 349
#define G 392
#define A 440
#define B 494
#define C2 524

char value[18*60];

int main()
{
 int key, freq, x;

 start_program();

 initialize();

 set_color (FGND_YELLOW);
 cursor (2, 40-sizeof(" The C Easy Music Maker ")/2);
 set_color (BKGND_RED);
 see(" The C Easy Music Maker ");
 set_color (BKGND_BLUE);

 erase (value, 18*60);
 cursor (24, 16);
 set_color (BKGND_GRAY); set_color (FGND_BLACK);
 see ("F3=Play, F4=Save, any key=Interrupt, Esc=Exit ");

 read_text ("musicfile", value, 60, 18);

 while (1)
  {
   enter_window (value, 60, 18, 4, 10);
   clear_line (SL);

   if (F4) savenow();
   if (ESCAPE_KEY) stop_program();
   if (*value == '!') break;

   for (x=0; x<(18*60); x++)
    {
     if (kbhit())
      {
       while (kbhit()) getch();
       break;
      }
     switch (value[x])
      {
       case 'a' : tone( C     ); break;
       case 's' : tone( D     ); break;
       case 'd' : tone( E     ); break;
       case 'f' : tone( F     ); break;
       case 'g' : tone( G     ); break;
       case 'h' : tone( A     ); break;
       case 'j' : tone( B     ); break;
       case 'k' : tone( C2    ); break;
       case 'l' : tone( C2+C  ); break;
       case 'z' : tone( C/2   ); break;
       case 'x' : tone( D/2   ); break;
       case 'c' : tone( E/2   ); break;
       case 'v' : tone( F/2   ); break;
       case 'b' : tone( G/2   ); break;
       case 'n' : tone( A/2   ); break;
       case 'm' : tone( B/2   ); break;
       case ',' : tone( C2/2  ); break;
       case 'q' : tone( C*2   ); break;
       case 'w' : tone( D*2   ); break;
       case 'e' : tone( E*2   ); break;
       case 'r' : tone( F*2   ); break;
       case 't' : tone( G*2   ); break;
       case 'y' : tone( A*2   ); break;
       case 'u' : tone( B*2   ); break;
       case 'i' : tone( C2*2  ); break;
       case 'o' : tone( C*4   ); break;
       case 'p' : tone( C2*4  ); break;
       case '1' : tone( C/5   ); break;
       case '2' : tone( D/5   ); break;
       case '4' : tone( E/5   ); break;
       case '5' : tone( F/5   ); break;
       case '6' : tone( G/5   ); break;
       case '7' : tone( A/5   ); break;
       case '8' : tone( B/5   ); break;
       case '9' : tone( C2/5  ); break;
       case '0' : tone( C2/10 ); break;
       case '-' : tone( 20    ); break;
       case '.' : tone( 40    ); break;
       case ';' : tone( 80    ); break;
       case '/' : tone( 160   ); break;
       case '[' : tone( 320   ); break;
       case ']' : tone( 640   ); break;
       case '\\' :tone( 0     ); break;
       case '!' : break;
       default  : break;
      }
     if (value[x] == '!') break;
    }
  }
 stop_program();
 return(0);
}

int initialize()
{
 if(GRAPHICS_MODE) set_graphics_mode(OFF);
 enable_time ('C', SL, 66);
 clear_screen (BKGND_GRAY, FGND_YELLOW);
 BKGND_TIME   = BKGND_GRAY;
 FGND_TIME    = FGND_BLUE;
 BKGND_WINDOW = BKGND_BLUE;
 FGND_WINDOW  = FGND_YELLOW;
 FGND_FRAME   = FGND_YELLOW;
 BKGND_FRAME  = BKGND_BLUE;
 FRAME_TYPE   = DOUBLE_LINE;
 SHADOW_TYPE  = RIGHT_SHADOW;
 BKGND_SHADOW = BKGND_BLACK;
 return(0);
}

int savenow()
{
 write_text ("musicfile", value, 60, 18);
 stop_program();
 return(0);
}
